#!/usr/bin/sh
#[gg] script to update 3rdparty's Makefile and Kconfig

thirdpartydir="$(readlink -f "$(dirname "$0")/../3rdparty")"

makefile="${thirdpartydir}/Makefile"
kconfigfile="${thirdpartydir}/Kconfig"

if [ ! -f "${makefile}" ]; then
	echo "error: can't find ${makefile}"
	exit 1
fi

if [ ! -f "${kconfigfile}" ]; then
	echo "error: can't find ${kconfigfile}"
	exit 1
fi

mv -f ${makefile} ${makefile}.bak
mv -f ${kconfigfile} ${kconfigfile}.bak

echo -e "#\n" >> ${kconfigfile}
echo -e "menu \"External 3rdparty kernel additions\"\n" >> ${kconfigfile}

echo -e "#\n" >> ${makefile}
echo -e "obj- := 3rdparty.o  # Dummy rule to force built-in.o to be made" >> ${makefile}

cd ${thirdpartydir}
len=0
	for i in *; do
		if [ -d "${i}" ]; then
			if [ -e "${i}/Kconfig" ]; then
				objname=$(cat ${i}/Kconfig | grep -m 1 config | awk '{print $2}')
				objname_alt=$(echo ${i} | tr '[a-z]' '[A-Z]')
				if [ -z "${objname}" ]; then
					objname="${objname_alt}"
				fi
				((${#objname} > len)) && len=${#objname}
				span=$((len+1))
				echo "source \"3rdparty/${i}/Kconfig\"" >> ${kconfigfile}
#				echo -e "obj-\$(CONFIG_${objname}) += ${i}/" >> ${makefile}
				printf "obj-\$(CONFIG_%-${span}s += ${i}/\n" "${objname})" >> ${makefile}
			fi
		fi
	done
echo -e "\nendmenu" >> ${kconfigfile}
cd ..
